unit OCIAPI;

interface

uses Windows;

const
//  
  OCI_LM_DEF = 0;
  OCI_LM_NBL = 1;

//  Oracle
  VERSION_7   = 2;
  NODEF_PARSE = 0;
  DEFER_PARSE = 1;

// SQL-
  SQL_INSERT = 3;
  SQL_SELECT = 4;
  SQL_UPDATE = 5;
  SQL_DELETE = 9;

//  
  oinVarChar2        = 1;
  oinNumber          = 2;
  oinLong            = 8;
  oinRowId           = 11;
  oinDate            = 12;
  oinRaw             = 23;
  oinLongRaw         = 24;
  oinChar            = 96;
  oinMSLLabel        = 105;

//   
  oexVarChar2       = 1; //pchar
  oexNumber         = 2; //array[1..21] of char
  oexInteger        = 3; //longint
  oexFloat          = 4; //double
  oexStringZ        = 5; //AnsiString
  oexVarNum         = 6; //array[1..22] of char
  oexPackedDecimal  = 7; //
  oexLong           = 8; //string
  oexVarChar        = 9; //array[1..slen] of char
  oexRowId          = 11;//
  oexDate           = 12;
  oexVarRaw         = 15;
  oexRaw            = 23;
  oexLongRaw        = 24;
  oexUnsignedInt    = 68;
  oexDisplay        = 91;
  oexLongVarChar    = 94;
  oexLongVarRaw     = 95;
  oexChar           = 96;
  oexCharZ          = 97;
  oexCursorVariable = 102;
  oexMLSLabel       = 105;

//      
  oviTrunc  = -2;
  oviNull   = -1;
  oviIntact = 0;

//ORACLE error codes
  oerrAllDataSelected = 1002;
  oerrVarNotInList    = 1007;
  oerrNoDataFound     = 1403;
  oerrNullValueReturn = 1405;

type
  RDRec = record
    rcs4: comp;
    rcs5: word;
    rcs6: byte;
  end;

  RIDRec = record
    rd:   RDRec;
    rcs7: comp;
    rcs8: word;
  end;

  CDAHeadRec = record
    v2_rc: smallint;
    ft:    word;
    rpc:   longint;
    peo:   word;
    fc:    byte;
    rcs1:  byte;
    rc:    word;
    wrn:   byte;
    rcs2:  byte;
    rcs3:  longint;
    rid:   RIDRec;
    ose:   longint;
    rcsp:  pointer;
  end;

  TCDA = ^CDADefRec;
  CDADefRec = record
    v2_rc: smallint;
    ft:    word;     //SQL Function Code
    rpc:   longint;  //Row Processed Count
    peo:   word;
    fc:    byte;
    rcs1:  byte;
    rc:    word;     //Return Code
    wrn:   byte;
    rcs2:  byte;
    rcs3:  longint;
    rid:   RIDRec;
    ose:   longint;
    rcsp:  pointer;
    rcs9:  array[0..63-SizeOf(CDAHeadRec)] of byte;
  end;

  text  = PChar;
  sword = Integer;
  uword = Integer;
  sb1   = Byte;
  ub1   = Byte;
  sb2   = Smallint;
  ub2   = Word;
  sb4   = Longint;
  ub4   = Cardinal;

  PByte  = ^Byte;
  PSmall = ^SmallInt;
  PSWord = ^sword;
(*
  pshort = ^shortint;
  pword  = ^word;
  psmall = ^smallint;
  pcard  = ^cardinal;
  plong  = ^longint;
  pint   = ^integer;
  *)

  TLDA = ^LDADefRec;
  LDADefRec = CDADefRec;

  THDA = ^HDADefArr;
  HDADefArr = array[byte] of byte;

TLog = function (lda: TLDA;      //  LDA-
                 hda: THDA;      //  HDA-
                 uid: pchar;     //     
                                 //      
                 uidl: sword;    //  
                 psw:  pchar;    //    
                 pswl: sword;    // 
                 con:  pchar;    //     
                 conl: sword;    //  
                 mode: word      //  
                                 //(  )
                ): sword; cdecl; //  "LDA return code"
                                 //0 -   

TLogof = function(plda: TLDA): sword; cdecl; //  "LDA return code"
                                                //0 - commit,  - rollback

//Commit
TCom = function (plda: TLDA): sword; cdecl;

//RollBack
TRol = function (plda: TLDA): sword; cdecl;

//     
TErhms = function (plda:   TLDA;
                   rcode:  sb2;       // 
                   buf:    PChar;     // 
                   bufsiz: sword      // 
                   ): sword; cdecl;
//n_chars = oerhms(&lda[1], cda.rc, msgbuf, (int) sizeof(msgbuf));


TClose = function (cursor: TCDA): sword; cdecl;

TOpen = function (cursor: TCDA;    //  CDA-
                  plda: TLDA;      //  LDA-
                  dbn: pchar;      //   c Oracle v2
                                   //  : 0
                  dbnl: sword;     //   c Oracle v2
                                   //  : -1
                  arsize: sword;   // Oracle v7  : -1
                  uid: pchar;      //  , 
                                   //    ( "/")
                  uidl: sword      //  
                  ): sword; cdecl; //  "CDA return code"
                                   //0 -  

TParse = function (cursor: TCDA;   //  CDA-
                  sqlstm: pchar;   //   SQL-
                  sqllen: sb4;     //  SQL-
                  defflg: sword;   //  
                  lngflg: ub4      //  SQL-
                                   //   
                                   //( Orcale v7 - VERSION_7)
                  ): sword; cdecl; //  "CDA return code"
                                      //0 -  

  //   
  //    SQL-
TBndrv = function (cursor: TCDA;   //  CDA-
                   sqlvar: pchar;  //    ( ":")
                   sqlvl: sword;   //    ( ":")
                   progv: pointer;   //   
                   progvl: sword;  //    
                   ftype: sword;   //   Oracle
                   scale: sword;   //   ,  <-1>
                   indp: pointer;  //   
                                   //  < 0,  
                                   //  NULL,  - 
                   fmt: pchar;     //   ,  <0>
                   fmtl: sword;    //   ,  <-1>
                   fmtt: sword     //   ,  <-1>
                   ): sword; cdecl; //0 -  


  //     
  //     SQL-
TBndra = function (cursor: TCDA;    //  CDA-
                   sqlvar: pchar;   //    
                   sqlvl: sword;    //  
                                    //(  -,  -1)
                   progv: pchar;    //     
                                    //    
                                    //     
                                    //  
                                    //SQL-
                   progvl: sword;   //   
                                    // (  > 64,  -1)
                   ftype: sword;    //   
                   scale: sword;    //  ( -1)
                   indp: pointer;   //    (2 byte)
                                    //(, , .)
                   alen: pointer;   //     (2 byte)
                                    // (  )
                   arcode: pointer; //    (2 byte)
                   maxsiz: ub4;     //   (<=32512)
                                    //  ,  0
                   cursiz: ub4;     //  .  
                                    //  ,  0
                   fmt: pchar;      //  ( 0)
                   fmtl: sword;     //  ( -1)
                   fmtt: sword      //  ( -1)
                   ): sword; cdecl; //  "CDA return code"
                                    //0 -  

TDescr = function (cursor: TCDA; //  CDA-
                  pos: sword;    //   select-
                                 //  1 ( )
                  dbsize: pointer; //   (4 byte),  
                                 //   
                  dbtype: pointer;//     (2 byte)
                  cbuf: pchar;   //    
                                 // 
                  cbufl: pointer;//   (4 byte)  
                  dsize: pointer;//   (4 byte)
                                 //   
                  prec: pointer; //   (2 byte) 
                                 //  ( )
                  scale: pointer;//   (2 byte) 
                                 //   
                  nullok: pointer//   (2 byte),  
                                 //    
                                 //0 - not null,  - null
                  ): sword; cdecl; //  "CDA return code"
                                   //0 -  

//    select- c  
TDefin = function (cursor: TCDA; //  CDA-
                   pos: sword;   //   select-
                                 //  1 ( )
                   buf: pbyte;   //    ()
                                 //    
                   bufl: sword;  //    
                                 //    
                                 //(   64,  -1)
                   ftype: sword; //    (. )
                   scale: sword; //  
                                 //  ( -1)
                   indp: pointer;//   (2 byte)  
                                 //(, , .)
                   fmt: pchar;   //  ( 0)
                   fmtl: sword;  //  ( -1)
                   fmtt: sword;  //  ( -1)
                   rlen: pointer; //   (2 byte),  
                                 //    
                                 //(  ,   
                                 //)   
                   rcode: pointer  //   (2 byte),  
                                 //   
                   ): sword; cdecl; //  "CDA return code"
//0    -  
//1405 -   
//1406 -     
//1454 -   
//1456 -       floating-point
//3115 -    

TDefinps = function (cursor: TCDA;      //  CDA-
                     opcode: byte;      // ,  - 1,  - 0
                     pos: sword;        //    (.  1)
                     buctx: pointer;    //   (1 byte) 
                                        //    
                     bufl: sb4;         //    (4 byte)
                     ftype: sword;      //  
                     scale: sword;      //0
                     indp: pointer;     //   (2 byte)
                     fmt:  pchar;       //nil
                     fmtl: sb4;         //0
                     fmtt: sword;       //0
                     rlenp: pointer;    //0
                     rcodep: pointer;   //0
                     buf_skip: sb4;     //    
                     ind_skip: sb4;     //    . 
                     len_skip: sb4;     //0
                     rc_skip:  sb4      //0
                     ): sword; cdecl;//  "CDA return code"
                                        //0 -  

TExec = function (cursor: TCDA): sword; cdecl; //  "CDA return code"
                                                 //0 -  

TFetch = function (cursor: TCDA): sword; cdecl;//  "CDA return code"
                                                 //0 -  

// nrows    odefin 
//    oexec
TExfet = function (cursor: TCDA;    //  CDA-
                   nrows:  ub4;     // -   
                   cancel: sword;   //  0,    
                                    //   
                   exact:  sword    //  0,    -
                                    //    ,
                                    //ORA-01403 "no data found" - nrows>real
                                    //ORA-01422 "more rows" - nrows<real
                                    //  CDA.rpc  
                                    //- 
                   ): sword; cdecl; //  "CDA return code"
                                    //0 -  

// nrows    odefin 
//   oexec  oexfet
TFen = function (cursor: TCDA; //  CDA-
                 nrows: sword  // -   
                 ): sword; cdecl;
// CDA.rpc -  -  
// CDA.rc -     (.     )

  TOraDate = packed record
    oraCentury : byte;
    oraYear : byte;
    oraMonth : byte;
    oraDay : byte;
    oraHour : byte;
    oraMinute : byte;
    oraSecond : byte;
  end;
  POraDate = ^TOraDate;

var
  hLib:     THandle;
  PFunc:    TFarProc;
  OLog:     TLog;
  OLogof:   TLogof;
  OCom:     TCom;
  ORol:     TRol;
  OErhms:   TErhms;
  OOpen:    TOpen;
  OClose:   TClose;
  OParse:   TParse;
  ODescr:   TDescr;
  ODefin:   TDefin;
  ODefinps: TDefinps;
  OExec:    TExec;
  OFetch:   TFetch;
  OExfet:   TExfet;
  OFen:     TFen;
  OBndrv:   TBndrv;
  OBndra:   TBndra;

implementation

initialization
  hLib := LoadLibrary('ociw32.dll');
  if hLib > HINSTANCE_ERROR then begin
    PFunc := GetProcAddress(hLib, 'olog');
    OLog := PFunc;

    PFunc := GetProcAddress(hLib, 'ologof');
    OLogof := PFunc;

    PFunc := GetProcAddress(hLib, 'ocom');
    OCom := PFunc;

    PFunc := GetProcAddress(hLib, 'orol');
    ORol := PFunc;

    PFunc := GetProcAddress(hLib, 'oerhms');
    OErhms := PFunc;

    PFunc := GetProcAddress(hLib, 'oopen');
    OOpen :=  PFunc;

    PFunc := GetProcAddress(hLib, 'oclose');
    OClose :=  PFunc;

    PFunc := GetProcAddress(hLib, 'oparse');
    OParse := PFunc;

    PFunc := GetProcAddress(hLib, 'odescr');
    ODescr := PFunc;

    PFunc := GetProcAddress(hLib, 'odefin');
    ODefin := PFunc;

    PFunc := GetProcAddress(hLib, 'odefinps');
    ODefinps := PFunc;

    PFunc := GetProcAddress(hLib, 'oexec');
    OExec :=  PFunc;

    PFunc := GetProcAddress(hLib, 'ofetch');
    OFetch := PFunc;

    PFunc := GetProcAddress(hLib, 'oexfet');
    OExfet := PFunc;

    PFunc := GetProcAddress(hLib, 'ofen');
    OFen := PFunc;

    PFunc := GetProcAddress(hLib, 'obndrv');
    OBndrv := PFunc;

    PFunc := GetProcAddress(hLib, 'obndra');
    OBndra := PFunc;
  end;

finalization
  if hLib > HINSTANCE_ERROR then
    FreeLibrary(hLib);
end.
